<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\PlanilhaCotacao\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class Sup02900EmissaoPlanilhaDeCotacaoController extends \Zeedhi\Framework\Controller\Report
{
    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $Sup02900EmissaoPlanilhaDeCotacaoService;

    public function __construct($reportService, $entityManager, $qr2Strategy, $newCode, $connection, $environment, $Sup02900EmissaoPlanilhaDeCotacaoService)
    {
        $this->reportService  = $reportService;
        $this->entityManager  = $entityManager;
        $this->qr2Strategy    = $qr2Strategy;
        $this->newCode        = $newCode;
        $this->connection     = $connection;
        $this->environment    = $environment;
        $this->Sup02900EmissaoPlanilhaDeCotacaoService = $Sup02900EmissaoPlanilhaDeCotacaoService;
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        $cdfilial = $this->environment->getCdFilial();
        $row["P_CDFILIAL"] = $this->Sup02900EmissaoPlanilhaDeCotacaoService->getCdFilial($cdfilial);
       
        $NRLISTA = $this->newCode->getCodeByTableName('NRLISTA', $this->environment->getNrorgTrab(), 1, 10, false);
        $this->insertLista($NRLISTA);
        
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
          array (
            'strategy' => $row['STRATEGY'],
            'parameterMapping' =>
                array (
                    "P_DTINICABE"  => "P_DTINICABE",
                    "P_DTFINCABE"  => "P_DTFINCABE",
                    "L_CDFORNECED" => "L_CDFORNECED",
                    "L_CDREGIAO"   => "L_CDREGIAO",
                    "P_DTINI"      => "P_DTINI",
                    "P_DTFIN"      => "P_DTFIN",
                    "P_CDINI"      => "P_CDINI",
                    "P_CDFIN"      => "P_CDFIN",
                    "P_CDFILIAL"   => "P_CDFILIAL"
                ),
            );
    }
    
    public function insertLista($nrlista)
    {
        $params = array(
            "NRLISTA" => $nrlista,
            "CDLISTA" => $this->environment->getCdOperador()
        );
        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
}
