<?php

namespace Teknisa\SUP\Util;

use SimpleXMLElement;

class XMLUtil
{

    /**
     * Receive a XML String and return a SimpleXMLElement Object.
     * 
     * @param string
     * @return array
     */
    public function parseStringXMLToObject(&$xml)
    {
        try {
            $xml = simplexml_load_string($xml);
        } catch (\Exception $e) {
            new Error($e->getMessage(), 1);
        }
    }

    /**
     * Receive a object and a SimpleXMLElement and returns the
     * SimpleXMLElement with object added on. 
     * 
     * @param object
     * @param SimpleXMLElement
     * @return SimpleXMLElement
     */
    public function addObjectOnXML($arrayToConvert, $xmlToAdd)
    {
        foreach ($arrayToConvert as $key => $value) {
            if (is_array($value)) {
                if (!is_numeric($key)) {
                    $subnode = $xmlToAdd->addChild("$key");
                    self::addObjectOnXML($value, $subnode);
                } else {
                    $subnode = $xmlToAdd->addChild("item$key");
                    self::addObjectOnXML($value, $subnode);
                }
            } else {
                $xmlToAdd->addChild($key, $value);
            }
        }
        return $xmlToAdd;
    }

    /**
     * Create and return a SimpleXMLElement with node 
     * "<arquivo>" (standardization).
     * 
     */
    public function createXMLElement()
    {
        $newXml = new SimpleXMLElement("<?xml version='1.0' encoding='UTF-8' standalone='no'?><arquivo></arquivo>");
        return $newXml;
    }
}
